#!/usr/bin/env python
#
#
#
#
#

"""
#TODO: documentation!
"""

__author__ = "$Author: DR0ID $"
__version__ = "$Revision: 82 $"
__date__ = "$Date: 2007-07-05 22:19:29 +0200 (Do, 05 Jul 2007) $"
__license__ = ''
__copyright__ = "DR0ID (c) 2007"
__url__ = "http://www.mypage.bluewin.ch/DR0ID/index.html"
__email__ = "dr0id@bluewin.ch"

import FastRenderGroup
import pygame

sprite = FastRenderGroup.DirtySprite

class _Quadrat(sprite):
    
    nr = 0
    
    def __init__(self, speedrange=3):
        sprite.__init__(self)
        self.__class__.nr+=1
        import random
        self.image = pygame.Surface((30,30)).convert_alpha()
        self.image.fill( (random.randint(0,255),random.randint(0,255),random.randint(0,255),128) )
        self.rect = self.image.get_rect()
        self.dirty = 2
        self.vx = 0
##        while 0==self.vx:
##            self.vx= speedrange*(random.random()-0.5)*2. #random.randint(-3,3)
        self.vy = 32
##        while 0==self.vy:
##            self.vy = speedrange*(random.random()-0.5)*2.#random.randint(-3,3)
        self.path_factor = 0.01
        self.maxX = (1-self.path_factor)*pygame.display.get_surface().get_width()
        self.minX = self.path_factor*pygame.display.get_surface().get_width()
        self.maxY = (1-self.path_factor)*pygame.display.get_surface().get_height()
        self.minY = self.path_factor*pygame.display.get_surface().get_height()
##        self.rect.center = (random.randint(100,700),random.randint(100,500))
        self.rect.center = (self.__class__.nr*31, random.randint(100, 300))
        self.posx = self.rect.x
        self.posy = self.rect.y
        
    def update(self):
        if self.rect.centerx > self.maxX or self.rect.centerx< self.minX:
            self.vx = -self.vx
        if self.rect.centery > self.maxY or self.rect.centery< self.minY:
            self.vy = -self.vy
        self.posx += self.vx
        self.posy += self.vy
        self.rect.center = (self.posx, self.posy)

class _Circle(_Quadrat):
    
    def __init__(self, speedrange=3):
        _Quadrat.__init__(self, speedrange)
        import random
        self.image = pygame.Surface((100,100)).convert_alpha()
        self.image.fill((0,0,0,0))
        pygame.draw.circle(self.image,(random.randint(0,255),random.randint(0,255),random.randint(0,255),128),(50,50) , 50)     
        self.rect = self.image.get_rect()
##        self.rect.center = (random.randint(300,600),random.randint(300,400))
        self.rect.center = (50, 200)
        self.__class__.nr -= 1
        self.vy = 100

class _StaticQuadrat(sprite):
    
    def __init__(self, pos, size):
        import random
        sprite.__init__(self)
        self.image = pygame.Surface(size).convert_alpha()
        self.image.fill((random.randint(0,255),random.randint(0,255),random.randint(0,255),128) )
        self.rect = pygame.Rect(pos, size)
        self.vx = self.vy =0
        self.dirty = 1

    
def main():
    """
    It is fast, but if you have enough sprites then a full screen udpate 
    will be faster. On my machine (Pentium M 1.5 Ghz, 1GB ram, ATI Radeion 9600)
    that is the case around 130 sprites (of this demo code). It is because of 
    the overhead involved using dirty rects. 
    
    Another thing is, if the code is stuttering from time to time, I assume that
    is either because of the garbagecollector or the CPU hogging (run it as 
    fast as possible and never letting other programs run).
    
    Issues:
    It seems that on AMD machines the render code will execute slower ( I do 
    not know why).
    
    """
    import time
    pygame.init()
    icon = pygame.image.load('logo32x32.png')
    pygame.display.set_caption('a=add, q=remove, f= toggle @10fps, esc=quit, r= toggle RenderUpdates & FastRenderGroup, c=clipping', 'FastRenderGroup')
    pygame.display.set_icon(icon)
    screen_size = (800, 600)
    pygame.display.set_mode(screen_size)
    screen = pygame.display.get_surface()
    
    renderer = FastRenderGroup.FastRenderGroup()
    render_update_group = pygame.sprite.RenderUpdates()
    print FastRenderGroup.VERSION
    clip = pygame.Rect(100,100,300,300)
    use_clip = False
    screen.fill((255,0,255))
    pygame.display.flip()
    sprites = []
    for i in range(10):
        spr = _Quadrat()
##        spr.vx = 0
##        spr.vy = 20
##        spr.rect.topleft = (100+i*11, 100)
        renderer.add(spr)
        sprites.append(spr)
    #circel
    c = _Circle()
    c.rect.topleft = (0,200)
    renderer.add(c)
    sprites.append(c)
    render_update_group.add(sprites)
    # static rects
    renderer.add(_StaticQuadrat((100,300), (100,300)))
    renderer.add(_StaticQuadrat((50,450), (600,100)))
    renderer.add(_StaticQuadrat((140,400), (300,300)))
    render_update_group.add(_StaticQuadrat((100,300), (100,300)))
    render_update_group.add(_StaticQuadrat((50,450), (600,100)))
    render_update_group.add(_StaticQuadrat((140,400), (300,300)))
    # background
    background = pygame.sprite.Sprite()
    background.image = pygame.Surface(screen_size).convert_alpha()
    background.image.fill((255,255,255))
    background.layer = -100
##    renderer.add(background)
##    renderer.set_clip(pygame.Rect(100,100,600,400))

    pygame.key.set_repeat(500, 20)
    n = 0
    slow = 0
    use_renderupdates = False
    clock = pygame.time.Clock()
    dirty_rects = []
    running = True
    while running:
        n += 1
        if n>=100:
            print "fps:",clock.get_fps()
            n = 0
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                running = False
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_f:
                slow ^= 1
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                running = False
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_a:
                if len(sprites):
                    q = _Quadrat()
                else:
                    q = _Circle()
                sprites.append(q)
                renderer.add(q)
                render_update_group.add(q)
                print "                                       num sprites:", len(sprites)
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_q:
                if len(sprites):
                    spr = sprites.pop()
                    spr.nr -= 1
                    renderer.remove(spr)
                    render_update_group.remove(spr)
                    print "                                       remove now num sprites:", len(sprites)
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_r:
                use_renderupdates = not use_renderupdates
                print "                                       using RenderUpdateGroup:", use_renderupdates
                screen.blit(background.image, (0,0))
                pygame.display.flip()
            elif event.type == pygame.KEYDOWN and event.key == pygame.K_c:
                use_clip = not use_clip
                if use_clip:
                    renderer.set_clip(clip)
                else:
                    renderer.set_clip()
        if slow:
            clock.tick(10)
        else:
            clock.tick()
            
        if use_renderupdates:
            render_update_group.update()
            render_update_group.clear(screen, background.image)
            dirty_rects = render_update_group.draw(screen)
        else:
            renderer.update()
            renderer.clear(screen, background.image)
            dirty_rects = renderer.draw(screen)
        pygame.display.update(dirty_rects)


    
if __name__ == "__main__":
##    import profile
##    profile.run('main()')
    main()
    
